﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.LightSwitch;
using Microsoft.LightSwitch.Security.Server;
using Telerik.Windows.Controls.ScheduleView;
using Telerik.Windows.Controls.ScheduleView.ICalendar;
namespace LightSwitchApplication
{
	public partial class ApplicationDataService
	{
		partial void LoadOnDemmandQuery_PreprocessQuery(DateTime? dateEnd, DateTime? dateStart, ref IQueryable<ScheduleViewAppt> query)
		{
			var result = query.ToList();

			DateTime start = dateStart.GetValueOrDefault();
			DateTime end = dateEnd.GetValueOrDefault();
			// Load the recurrent appointments
			foreach (ScheduleViewAppt item in this.ScheduleViewAppts.Where(a => !string.IsNullOrEmpty(a.RecurrenceRule)))
			{
				if (IsOccurrenceInRange(item.RecurrenceRule, start, end))
				{
					result.Add(item);
				}
			}

			query = result.AsQueryable<ScheduleViewAppt>();
		}

		private bool IsOccurrenceInRange(string valueToParse, DateTime start, DateTime end)
		{
			RecurrencePattern pattern = new RecurrencePattern();
			if (RecurrencePatternHelper.TryParseRecurrencePattern(valueToParse, out pattern))
			{
				return pattern.GetOccurrences(start, start, end).Count() > 0;
			}

			return false;
		}

	}
}
